# -*- coding: utf-8 -*-
"""
Created on Thu Sep 10 23:48:07 2020

@author: UsamaManzoor
"""

##------------------------------------AutoEncoder--------------------------------------------  
from keras.models import Model 
from keras.layers import Input, Dense
from sklearn import datasets, linear_model
from sklearn.model_selection import train_test_split
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
from os import listdir
from os.path import isfile, join

i=0
set=np.load('E:/Research/dataPSSP/Data%i.npy'%i)
for i in range(1, 6133):
    dataset1=np.load('E:/Research/dataPSSP/Data%i.npy'%i)
    set=np.concatenate((set,dataset1))
     print(i)

set = np.load('D:/Research/FeatureSelection/Dataset/Initial_Data.npy')
encoding_dim = 15



input_vec = Input(shape=(21,))

encoded = Dense(encoding_dim, activation='relu')(input_vec)

decoded = Dense(21, activation='softmax')(encoded)

autoencoder = Model(input_vec, decoded)

encoder = Model(input_vec, encoded)

encoded_input = Input(shape=(encoding_dim,))

decoder_layer = autoencoder.layers[-1]

decoder = Model(encoded_input, decoder_layer(encoded_input))

encoder.summary()
decoder.summary()
autoencoder.summary()


autoencoder.compile(optimizer='adadelta', loss='binary_crossentropy')

x_train, x_test = train_test_split(set, test_size=0.2)

x_train = x_train.reshape((len(x_train),(np.prod(x_train.shape[1:]))))
x_test = x_test.reshape((len(x_test),(np.prod(x_test.shape[1:]))))

x_train.dtype, x_test.dtype
print(x_train)
print(x_test)
print(f'x_train shape = {x_train.shape}')
print(f'x_test shape = {x_test.shape}')
# traning Parameters
H = autoencoder.fit(x_train, x_train,
                epochs=50,
                batch_size=256,
                shuffle=True,
                validation_data=(x_test, x_test))

encoded_data = encoder.predict(x_train)
decoded_data = decoder.predict(encoded_data)

en_coded_data = encoder.predict(x_test)
decodedData = decoder.predict(en_coded_data)

plt.show()


data1 = np.concatenate((encoded_data, en_coded_data))

#for data saving
#from numpy import save

#save('E:/Research/Dataset/Final.npy', data1)

#from numpy import save
#for i in range(Final_data.shape[0]):
#  save('E:/Research/Dataset/AE_Data/AE_Data%i.npy'%i, Final_data[i])