# -*- coding: utf-8 -*-
"""
Created on Sun Nov  1 23:14:51 2020

@author: UsamaManzoor
"""
import numpy as np
from sklearn.multiclass import OneVsRestClassifier
from sklearn.svm import SVC
from sklearn.model_selection import train_test_split
from sklearn.tree import DecisionTreeClassifier
X = np.load('E:/Research/Split/Initial_Data.npy')    
array = np.load('E:/Research/Dataset/Label.npy')
y  = np.argmax(array, axis=1)
print(X.shape); print(y.shape)

train = np.load('E:/Research/Split/X_train.npy') 
X_test =  np.load('E:/Research/Split/X_test.npy') 
ytrain = np.load('E:/Research/Split/Y_train.npy') 
y_test = np.load('E:/Research/Split/Y_test.npy') 
X_val = np.load('E:/Research/Split/ X_validation.npy') 
y_val = np.load('E:/Research/Split/Y_validation.npy') 
rus = RandomOverSampler(random_state=42)
X_train, y_train = rus.fit_resample(X_train, ytrain)
print(X_train.shape); print(X_test.shape)

# Make a decision tree and train
tree = DecisionTreeClassifier(random_state=42)
tree.fit(X, y)
print(f'Model Accuracy: {tree.score(X, y)}')


predict_train = tree.predict(X_train)
predict_test = tree.predict(X_test)
from sklearn.metrics import classification_report,confusion_matrix
print(confusion_matrix(y_train,predict_train))
print(classification_report(y_train,predict_train))
print(confusion_matrix(y_test,predict_test))
print(classification_report(y_test,predict_test))