# GenericUnivariateSelect is a sklearn.feature_selection tool that allows you to select features from a dataset using a scoring function. It supports selecting columns in one of a few different configurations: k for when you want a specific number of columns, percentile for when you want to a percentage of the total number of columns, and so on.
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import seaborn as sns

from sklearn.feature_selection import GenericUnivariateSelect
X = np.load('D:/Research/FeatureSelection/Dataset/Initial_Data.npy')
y = np.load('D:/Research/FeatureSelection/Dataset/Label.npy')
#X= df.values
trans = GenericUnivariateSelect(score_func=lambda X, y: X.mean(axis=0), mode='percentile', param=85)
chars_X_trans = trans.fit_transform(X, y)
print("We started with {0} features but retained only {1} of them!".format(X.shape[1], chars_X_trans.shape[1]))

my_list = trans.scores_


#from numpy import savetxt
#for i in range(X.shape[0]):
#  savetxt('E:/Research/PSSP_CSV/Data%i.csv'%i, X[i], delimiter=',')
from numpy import save
save('D:/Research/FeatureSelection/Dataset/FS1/FS_21.npy', chars_X_trans)