# -*- coding: utf-8 -*-
"""
Created on Wed Nov 11 23:15:36 2020

@author: UsamaManzoor
"""
from sklearn.model_selection import train_test_split
from collections import Counter
import numpy as np
X = np.load('E:/Research/Split/Train_MI.npy')    
array = np.load('E:/Research/Split/Train_Labels.npy')
y  = np.argmax(array, axis=1)

train = np.load('E:/Research/Split/X_train.npy') 
X_test =  np.load('E:/Research/Split/X_test.npy') 
ytrain = np.load('E:/Research/Split/Y_train.npy') 
y_test = np.load('E:/Research/Split/Y_test.npy') 
X_val = np.load('E:/Research/Split/ X_validation.npy') 
y_val = np.load('E:/Research/Split/Y_validation.npy') 
rus = RandomOverSampler(random_state=42)
X_train, y_train = rus.fit_resample(X_train, ytrain)

#Import Random Forest Model


from sklearn.ensemble import RandomForestClassifier

#Create a Gaussian Classifier
clf=RandomForestClassifier(n_estimators=100)

#Train the model using the training sets y_pred=clf.predict(X_test)
clf.fit(X_train,y_train)

y_pred=clf.predict(X_test)

from sklearn import metrics
# Model Accuracy, how often is the classifier correct?
print("Accuracy:",metrics.accuracy_score(y_test, y_pred))



predict_train = clf.predict(X_train)
predict_test = clf.predict(X_test)
from sklearn.metrics import classification_report,confusion_matrix
print(confusion_matrix(y_train,predict_train))
print(classification_report(y_train,predict_train))
print(confusion_matrix(y_test,predict_test))
print(classification_report(y_test,predict_test))


C = np.load('E:/Research/Split/Test_MI.npy')    
t = np.load('E:/Research/Split/Test_Labels.npy')
z_te = np.argmax(t, axis=1) + 1
z_te[~t.any(axis=1)] = 0

z_test = z_te[z_te!=0]
Z_test = C[z_te!=0]

predict_train = clf.predict(X_train)
predict_test = clf.predict(Z_test)
from sklearn.metrics import classification_report,confusion_matrix
print(confusion_matrix(y_train,predict_train))
print(classification_report(y_train,predict_train))
print(confusion_matrix(z_test,predict_test))
print(classification_report(z_test,predict_test))

observed = Counter(z_test)
predicted = confusion_matrix(z_test,predict_test)

Q8 = 0
for i in range(predicted.shape[0]):  # per element in the batch
        for j in range(predicted.shape[1]): # per aminoacid residue
            if i == j:  #  real[i, j, dataset.num_classes - 1] > 0 # if it is padding
                Q8 = Q8 +( (predicted[i,j]/observed[i])*100)
           
print(Q8)
